library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity hsync_tb is
-- port()
end entity;

architecture Behavioral of hsync_tb is
    -- KONSTANTE 
    constant CLOCK_PERIOD: time := 40 ns;
    
    -- KOMPONENTE 
    -- UUT 
    component hsync is
        Port ( clk : in STD_LOGIC;
             rst : in STD_LOGIC;
             hsync : out STD_LOGIC);
    end component;
    -- SIGNALI
    -- vhodni / generirani signali (draljaji)
    signal clk_gen, rst_gen: std_logic := '0';
    -- izhodni signali (grejo na osciloskop) 
    signal hsync_out: std_logic := '0';

begin

    UUT: hsync
        port map(
            clk => clk_gen,
            rst => rst_gen,
            hsync => hsync_out
        );

    -- Generiranje draljajev 
    clk_stimuli: process
    begin
        -- alternativa:
        --clk_gen <= '0';
        --wait for CLOCK_PERIOD/2;
        --clk_gen <= '1';
        --wait for CLOCK_PERIOD/2;
        
        clk_gen <= not clk_gen;
        wait for CLOCK_PERIOD/2;
    end process;
    
    oth_stimuli: process
    begin 
        -- dolg reset 
        rst_gen <= '1';
        wait for CLOCK_PERIOD*5;
        rst_gen <= '0';
        -- akaj neskonno 
        wait; 
    end process;

end architecture;
